clear all;

for num_sequences=1:32

seq_name = sprintf('seq_mimofb_on_fast_%d.txt',num_sequences);

header{1} = '#';
header{2} = '# Description: $description';
header{3} = '# Author: Sequencer Library';
header{4} = '# Date: 2019/05/31';
header{5} = '#';
header{6} = sprintf('# This sequence switches fastly ON/STANDBY/OFF %d mimo feedbacks',num_sequences);
header{7} = '#';


standby_step = 4 + num_sequences * 3;
off_step = standby_step + num_sequences * 2 + 3;
final_check_step = off_step +num_sequences * 2 + 2;

cnt = 0;
cnt = cnt + 1;
blk{cnt}=sprintf('step%d;(write(this/FbDone) = 0) && (write(this/ErrCountStart) = read($devmon_attr)) &&  (read(this/ImmediateOff) == 1) ? goto(%d) : goto(%d);Reset variables;Error resetting variables;-1',cnt,off_step,cnt+1);

% Turn feedbacks ON
for seq=1:num_sequences
    cnt = cnt + 1;
    blk{cnt} = sprintf('step%d;((read(this/EnableFb%d) == 1) && (read($devfb%d$/State) != ON) && (read($devfb%d$/State) != MOVING)) ? command($devfb%d$/On) && goto(%d) : goto(%d);Starting $devfb%d$ local feedback;Error starting $devfb%d$ local feedback;-1;tangoerror=goto(%d)',cnt,seq,seq,seq,seq,cnt+1,cnt+1,seq,seq,cnt+1);
end

cnt = cnt + 1;
blk{cnt}=sprintf('step%d;sleep($sleep_monitor_state) && sleep($sleep_wait_refresh_state) && (write(this/FbDone) = 0) && goto(%d);Waiting feedback convergence;Error waiting feedback convergence;$correction_timeout000;timeouterror=goto(%d)',cnt,cnt+1,standby_step);

% Wait feedback going under error threshold
for seq=1:num_sequences
    cnt = cnt + 1;
    blk{cnt} = sprintf('step%d;((read($devfb%d$/TargetDistance) < read(this/TargetDistanceThreshold)) || (read(this/EnableFb%d) == 0)) ? (write(this/FbDone) = (read(this/FbDone) + 1)) && goto(%d) : goto(%d);Checking $devfb%d$ error;Error checking $devfb%d$ error;-1;tangoerror=goto(%d)',cnt,seq,seq,cnt+1,cnt+1,seq,seq,standby_step);
    cnt = cnt + 1;
    blk{cnt} = sprintf('step%d;read(this/ErrCountStart) < read($devmon_attr) ? goto(%d) : goto(%d);Checking external error condition;Error checking external error condition;-1',cnt,standby_step,cnt+1);
end

cnt = cnt + 1;
blk{cnt}=sprintf('step%d;read(this/FbDone) >= %d ? goto(%d) : goto(%d);Check all feedback converged;Error checking all feedback converged;-1',cnt,num_sequences,cnt+1,cnt-num_sequences*2-1);

% Turn feedbacks in STANDBY
for seq=1:num_sequences
    cnt = cnt + 1;
    % exit condition in the first line 
    if seq == 1
        blk{cnt} = sprintf('step%d;((read(this/EnableFb%d) == 1) && ((read($devfb%d$/State) == ON) || (read($devfb%d$/State) == MOVING))) ? command($devfb%d$/Standby) && goto(%d) : goto(%d);Standbying $devfb%d$ feedback;Error standbying $devfb%d$ feedbacks;-1;tangoerror=goto(%d),exit',cnt,seq,seq,seq,seq,cnt+1,cnt+1,seq,seq,cnt+1);
    else
        blk{cnt} = sprintf('step%d;((read(this/EnableFb%d) == 1) && ((read($devfb%d$/State) == ON) || (read($devfb%d$/State) == MOVING))) ? command($devfb%d$/Standby) && goto(%d) : goto(%d);Standbying $devfb%d$ feedback;Error standbying $devfb%d$ feedbacks;-1;tangoerror=goto(%d)',cnt,seq,seq,seq,seq,cnt+1,cnt+1,seq,seq,cnt+1);
    end
end

cnt = cnt + 1;
blk{cnt}=sprintf('step%d;sleep($sleep_wait_refresh_state) && (write(this/FbDone) = 0) && goto(%d);Reset variables;Error resetting variables;$wait_timeout_state000;timeouterror=goto(%d)',cnt,cnt+1,off_step);

% Wait feedback going in STANDBY state
for seq=1:num_sequences
    cnt = cnt + 1;
    blk{cnt} = sprintf('step%d;((read($devfb%d$/State) == OFF) || (read($devfb%d$/State) == STANDBY) || (read(this/EnableFb%d) == 0)) ? (write(this/FbDone) = (read(this/FbDone) + 1)) && goto(%d) : goto(%d);Checking $devfb%d$ error;Error checking $devfb%d$ error;-1;tangoerror=goto(%d)',cnt,seq,seq,seq,cnt+1,cnt+1,seq,seq,off_step);
end

cnt = cnt + 1;
blk{cnt}=sprintf('step%d;read(this/FbDone) >= %d ? goto(%d) : goto(%d);Check all feedback in STANDBY;Error checking all feedback in STANDBY;-1',cnt,num_sequences,cnt+1,cnt-num_sequences-1);

% exit on standby
cnt = cnt + 1;
blk{cnt}=sprintf('step%d;read(this/ExitOnStandby) == 1 ? goto(%d) : goto(%d);Exiting on STANDBY;Error exiting on STANDBY;-1',cnt,final_check_step,cnt+1);

% Turn feedbacks in OFF
for seq=1:num_sequences
    cnt = cnt + 1;
    blk{cnt} = sprintf('step%d;((read(this/EnableFb%d) == 1) && ((read($devfb%d$/State) == STANDBY) || (read($devfb%d$/State) == FAULT))) ? command($devfb%d$/Off) && goto(%d) : goto(%d);Turning off $devfb%d$ feedback;Error turning off $devfb%d$ feedbacks;-1;tangoerror=goto(%d)',cnt,seq,seq,seq,seq,cnt+1,cnt+1,seq,seq,cnt+1);
end

cnt = cnt + 1;
blk{cnt}=sprintf('step%d;(write(this/FbDone) = 0) && sleep($sleep_wait_refresh_state) &&  goto(%d);Reset variables;Error resetting variables;$wait_timeout_state000;timeouterror=goto(%d)',cnt,cnt+1,final_check_step);

% Wait feedback going in STANDBY state
for seq=1:num_sequences
    cnt = cnt + 1;
    blk{cnt} = sprintf('step%d;((read($devfb%d$/State) == OFF) || (read(this/EnableFb%d) == 0))? (write(this/FbDone) = (read(this/FbDone) + 1)) && goto(%d) : goto(%d);Checking $devfb%d$ OFF state;Error checking $devfb%d$ OFF state;-1;tangoerror=goto(%d)',cnt,seq,seq,cnt+1,cnt+1,seq,seq,cnt+1);
end

cnt = cnt + 1;
blk{cnt}=sprintf('step%d;read(this/FbDone) >= %d ? (write(this/FbDone) = 0) && goto(%d) : goto(%d);Check all feedback in OFF state;Error checking all feedback in OFF state;-1',cnt,num_sequences,cnt+1,cnt-num_sequences-1);

% Wait feedback going in STANDBY state
for seq=1:num_sequences
    cnt = cnt + 1;
    blk{cnt} = sprintf('step%d;read(this/EnableFb%d) == 0 ? (write(this/FbDone) = (read(this/FbDone) + 1)) && goto(%d) : goto(%d);Checking $devfb%d$ OFF state(1);Error checking $devfb%d$ OFF state(1);-1',cnt,seq,cnt+2,cnt+1,seq,seq);
    cnt = cnt + 1;
    blk{cnt} = sprintf('step%d;(((((read($devfb%d$/State) == STANDBY) && (read(this/ExitOnStandby) == 1)) || (read($devfb%d$/State) == OFF)) && (read($devfb%d$/TargetDistance) <= (read(this/TargetDistanceThreshold)*10))) || (read(this/EnableFb%d) == 0)) ? (write(this/FbDone) = (read(this/FbDone) + 1)) && goto(%d) : goto(%d);Checking $devfb%d$ OFF state(1);Error checking $devfb%d$ OFF state(1);-1',cnt,seq,seq,seq,seq,cnt+1,cnt+1,seq,seq);
end

cnt = cnt + 1;
blk{cnt}=sprintf('step%d;((read(this/FbDone) >= %d) || (read(this/ImmediateOff) == 1)) ? goto(%d) : goto(-1);Exit;Exit on error;-1',cnt,num_sequences,cnt+1);



% dynamic attributes
cnt = 0; 
for seq=1:num_sequences
    cnt = cnt + 1;
    footer{cnt} = sprintf('attr;EnableFb%d;bool;1',seq);
end
cnt = cnt + 1;
footer{cnt} = 'attr;ExitOnStandby;bool;0';
cnt = cnt + 1;
footer{cnt} = 'attr;ImmediateOff;bool;0';
cnt = cnt + 1;
footer{cnt} = 'attr;TargetDistanceThreshold;double;0';
cnt = cnt + 1;
footer{cnt} = 'attr;FbDone;long;0';
cnt = cnt + 1;
footer{cnt} = 'attr;ErrCountStart;long;0';


fileID = fopen(seq_name,'w');
for i=1:size(header,2)
    fprintf(fileID,'%s\n',header{i});
end
for i=1:size(blk,2)
    fprintf(fileID,'%s\n',blk{i});
end
for i=1:size(footer,2)
    fprintf(fileID,'%s\n',footer{i});
end

fclose(fileID);

end

% Dynamic R/W attributes
% Internal
% attr;ErrorCnt;long;0
% attr;MonitorErrorCnt;long;0

% Wildcards
% $description=
% $sleep_wait_refresh_state=4
% $timeout_wait_state=10
% $correction_timeout=120
% $devfb1=
% $devfb2=
% $devfb3=
% .........


